
/* .equsymbol, expression
 * These directive set the value of the symbol to the expression
 */
    .equ    BOOT_SEGMENT,0x07c0
    .equ    DISPLAY_SEGMENT,0xb800
    
    .equ    STACK_SEGMENT, 0x9000
    .equ    STACK_BOTTOM, 0xfffe

    .equ    KERNEL_SEGMENT, 0x0000
    .equ    KERNEL_OFFSET, 0x1000

.text		/* Code segment */
.globl  _start	/* The entry point must be global */
.code16		/* Real mode */

/*
 * The first instruction to execute in a program is called the entry
 * point. The linker expects to find the entry point in the "symbol" _start
 * (with underscore).
 */

_start:
        jmp     over
os_size:
	/* Area reserved for createimage to write the OS size */
        .word   0
        .word   0

over:
    /* setting ds = BOOT_SEGMENT (what cs should be) */
        movw    $BOOT_SEGMENT,%ax
        movw    %ax,%ds

    /* set up stack */
        movw    $STACK_SEGMENT,%bx
        movw    %bx,%ss
        movw    $STACK_BOTTOM, %sp
        movw    $STACK_BOTTOM, %bp

    /* load kernel from floppy disk */
        movw    $KERNEL_SEGMENT, %bx
        movw    %bx,%es
        movw    $KERNEL_OFFSET,%bx
        
        movw    $os_size,%si
        movb    (%si), %al

        movb    $2, %ah 
        movb    $0, %ch 
        movb    $2, %cl 
        movb    $0, %dh 

        int     $0x13

        movw    $KERNEL_SEGMENT,%bx
        movw    %bx,%ds

    /* jump to the new kernel */
        ljmp    $KERNEL_SEGMENT,$KERNEL_OFFSET

    /* loop if the jump failed */
forever: 
        jmp     forever
