.data
	.set	ASC_NO_SHIFT, 0
	.set	ASC_SHIFT, 1
	.set	ASC_CONTROL, 2

	.set	SCAN_ESC, 0x01
	.set	SCAN_CTRL, 0x1d
	.set	SCAN_LSHIFT, 0x2a
	.set	SCAN_RSHIFT, 0x36
	.set	SCAN_ALT, 0x38
	.set	SCAN_CAPS, 0x3a
	.set	SCAN_NUMLOCK, 0x45
	.set	SCAN_SCROLL, 0x46

scan_codes:
	.byte 0x00, 	0x00, 	0x00	
	.byte 0x1b, 	0x1b, 	0x1b	# ESC		0x01
	.byte 0x31, 	0x21, 	0x00	
	.byte 0x32, 	0x40, 	0x00
	.byte 0x33, 	0x23, 	0x00
	.byte 0x34, 	0x24, 	0x00
	.byte 0x35, 	0x25, 	0x00
	.byte 0x36, 	0x5e, 	0x1e
	.byte 0x37, 	0x26, 	0x00
	.byte 0x38, 	0x2a, 	0x00
	.byte 0x39, 	0x28, 	0x00
	.byte 0x30, 	0x29, 	0x00
	.byte 0x2d, 	0x5f, 	0x1f
	.byte 0x3d, 	0x2b, 	0x00
	.byte 0x08, 	0x08, 	0x7f
	.byte 0x09, 	0x00, 	0x00	#		0x0f
	.byte 0x71, 	0x51, 	0x11
	.byte 0x77, 	0x57, 	0x17
	.byte 0x65, 	0x45, 	0x05
	.byte 0x72, 	0x52, 	0x12
	.byte 0x74, 	0x54, 	0x14
	.byte 0x79, 	0x59, 	0x19
	.byte 0x75, 	0x55, 	0x15
	.byte 0x69, 	0x49, 	0x09
	.byte 0x6f, 	0x4f, 	0x0f
	.byte 0x70, 	0x50, 	0x10
	.byte 0x5b, 	0x7b, 	0x1b	#		0x1a
	.byte 0x5d, 	0x7d, 	0x1d
	.byte 0x0d, 	0x0d, 	0x0a
	.byte 0x00, 	0x00, 	0x00	# CTRL
	.byte 0x61, 	0x41, 	0x01
	.byte 0x73, 	0x53, 	0x13
	.byte 0x64, 	0x44, 	0x04	#		0x20
	.byte 0x66, 	0x46, 	0x06
	.byte 0x67, 	0x47, 	0x07
	.byte 0x68, 	0x48, 	0x08
	.byte 0x6a, 	0x4a, 	0x0a
	.byte 0x6b, 	0x4b, 	0x0b
	.byte 0x6c, 	0x4c, 	0x0c
	.byte 0x3b, 	0x3a, 	0x00
	.byte 0x27, 	0x22, 	0x00
	.byte 0x60, 	0x7e, 	0x00
	.byte 0x00, 	0x00, 	0x00	# LEFT_SHIFT	0x2a
	.byte 0x5c, 	0x7c, 	0x00
	.byte 0x7a, 	0x5a, 	0x1a
	.byte 0x78, 	0x58, 	0x18
	.byte 0x63, 	0x43, 	0x03
	.byte 0x76, 	0x56, 	0x16
	.byte 0x62, 	0x42, 	0x02	# 		0x30
	.byte 0x6e, 	0x4e, 	0x0e
	.byte 0x6d, 	0x4d, 	0x0d
	.byte 0x2c, 	0x3c, 	0x00
	.byte 0x2e, 	0x3e, 	0x00
	.byte 0x2f, 	0x3f, 	0x00
	.byte 0x00, 	0x00, 	0x00	# RIGHT_SHIFT	0x36
	.byte 0x2a, 	0x2a, 	0x00
	.byte 0x00, 	0x00, 	0x00	# ALT		0x38
	.byte 0x20, 	0x20, 	0x00
	.byte 0x00, 	0x00, 	0x00	# CAPS		0x3a
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00	#		0x40
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00
	.byte 0x00, 	0x00, 	0x00	# NUM_LOCK	0x45
	.byte 0x00, 	0x00, 	0x00	# SCROLL_LOCK	0x46
	.byte 0x00, 	0x37, 	0x00
	.byte 0x00, 	0x38, 	0x00
	.byte 0x00, 	0x39, 	0x00
	.byte 0x2d, 	0x2d, 	0x00
	.byte 0x00, 	0x34, 	0x00
	.byte 0x00, 	0x35, 	0x00
	.byte 0x00, 	0x36, 	0x00
	.byte 0x2b, 	0x2b, 	0x00
	.byte 0x00, 	0x31, 	0x00
	.byte 0x00, 	0x32, 	0x00	#		0x50
	.byte 0x00, 	0x33, 	0x00
	.byte 0x00, 	0x30, 	0x00
	.byte 0x00, 	0x2e, 	0x00

shift_status:
	.word 0
key_release:
	.word 0

	.set 	LEFT_SHIFT, 1
	.set	RIGHT_SHIFT, 2
	.set	CAPS_SHIFT, 4
	.set	CONTROL, 8
	.set	ALT, 16
.text
.code16

.globl getchar
.globl keyboard_entry

normal_handler:
	pushw	%bp
	movw	%sp, %bp
	movw    (key_release), %dx
	cmpw	$0, %dx
	je	normal_handler_a
	# key release
	popw	%bp
	retw
	# key press
normal_handler_a:
	movw	4(%bp), %bx			# scan code
	movw	%bx, %ax
	addw	%ax, %bx
	addw	%ax, %bx			# arg * 3
	addw	$scan_codes, %bx
	movw	(shift_status), %dx
	cmpw	$LEFT_SHIFT, %dx
	je	key_normal_shift
	cmpw	$RIGHT_SHIFT, %dx
	je	key_normal_shift
	cmpw	$CAPS_SHIFT, %dx
	je	key_normal_shift
	cmpw	$CONTROL, %dx
	je	key_normal_ctrl
	cmpw	$0, %dx
	je	key_normal_normal
	movb	$0, %dl
key_normal_put:
	movb	%al, %dh		/* scan code */
	pushw	%dx
	call	putchar
	addw	$2, %sp
	popw	%bp
	retw
key_normal_shift:
	xorw	%dx, %dx
	movb	ASC_SHIFT(%bx), %dl
	jmp	key_normal_put
key_normal_ctrl:
	xorw	%dx, %dx
	movb	ASC_CONTROL(%bx), %dl
	jmp	key_normal_put
key_normal_normal:
	xorw	%dx, %dx
	movb	ASC_NO_SHIFT(%bx), %dl
	jmp	key_normal_put


# Some keys on standard 101/102-key keyboards (and the Microsoft 
# Natural keyboard amongst others) emit a sequence of two bytes, 
# where the 1st byte is either 0xE0 or 0xE1. This method is used 
# primarily to distinguish between left and right versions of the 
# same key, e.g., Left Alt is 0x38 while Right Alt is 0xE0 0x38. 
# The 0xE0 prefix is indicated as the "extended bit" (bit 24) in 
# the lParam of messages such as WM_KEYDOWN. The 0xE1 prefix is 
# much rarer, but operates similarly to the 0xE0 prefix.

key_interrupt:
	xorw	%ax, %ax
	movw	$0x60, %dx
	inb	%dx, %al
	cmpw	$0xe0, %ax
	jne	key_int_a0
	retw
key_int_a0:
	cmpw	$0xe1, %ax
	jne	key_int_a1
	retw
key_int_a1:
	movw	%ax, %dx
	andw	$0x80, %dx		# key_release or not
	cmpw	$0, %dx
	je	key_int_press
	movw	$1, (key_release)
	jmp	key_int_b
key_int_press:
	movw	$0, (key_release)
key_int_b:
	andw	$0x7f, %ax
	cmpw	$SCAN_ESC, %ax
	je	key_int_done		# esc not supported
	cmpw	$SCAN_CTRL, %ax
	je	key_int_ctrl
	cmpw	$SCAN_LSHIFT, %ax
	je	key_int_lshift
	cmpw	$SCAN_RSHIFT, %ax
	je	key_int_rshift
	cmpw	$SCAN_ALT, %ax
	je	key_int_alt
	cmpw	$SCAN_CAPS, %ax
	je	key_int_caps
	cmpw	$SCAN_NUMLOCK, %ax
	je	key_int_done
	cmpw	$SCAN_SCROLL, %ax
	je	key_int_done
	cmpw	$0x54, %ax
	jge	key_int_done		# ax >= $0x54
	pushw	%ax
	call	normal_handler
	addw	$2, %sp
key_int_done:
	retw
key_int_ctrl:
	movw	$CONTROL, %ax
	jmp	key_int_status
key_int_lshift:
	movw	$LEFT_SHIFT, %ax
	jmp	key_int_status
key_int_rshift:
	movw	$RIGHT_SHIFT, %ax
	jmp	key_int_status
key_int_alt:
	movw	$ALT, %ax

	# ax now contains the mask code
key_int_status:
	movw	(key_release), %dx
	movw	(shift_status), %cx
	cmpw	$0, %dx
	jne	key_int_status_a
	# key press
	orw	%ax, %cx
	movw	%cx, (shift_status)
	retw
key_int_status_a:			# key release
	notw	%ax
	andw	%ax, %cx
	movw	%cx, (shift_status)
	retw
key_int_caps:
	movw	$CAPS_SHIFT, %ax
	movw	(shift_status), %cx
	movw	(key_release), %dx
        cmpw    $0, %dx
        jne     key_int_caps_a
        # key press
	movw	%cx, %dx
	andw	%ax, %dx
	cmpw	$0, %dx
	jne	key_int_caps_b
	# turn on caps
	orw	%ax, %cx
	jmp	key_int_caps_c

	# turn off caps
key_int_caps_b:
	notw	%ax
	andw	%ax, %cx
key_int_caps_c:
	movw	%cx, (shift_status)
key_int_caps_a:
	retw

keyboard_entry:				/* 0x167d */
        call    critical_in
        pushw   %ax
        pushw   %bx
        pushw   %cx
        pushw   %dx
        pushw   %di
        pushw   %si
        pushw   %bp
	call	inc_nest_cnt
	call	critical_out
	call	key_interrupt
	call	critical_in
	call	dec_nest_cnt
        movb    $0x20, %al
        movw    $0x20, %dx
        outb    %al, %dx                # send EOI
        popw    %bp
        popw    %si
        popw    %di
        popw    %dx
        popw    %cx
        popw    %bx
        popw    %ax
        call    critical_out
        iret

/* putchar is called by the keyboard interrupt handler */
/* assert : curr_thrd.NESTCNT > 0 */
putchar:
	pushw	%bp
	movw	%sp, %bp
	movw	4(%bp), %ax
	pushw	%ax
	call	mb_put_asyn
	addw	$2, %sp
	popw	%bp
	retw

/* getchar is called by user thread (consumer) */
getchar:
	call    critical_in
	call	mb_get
	call	critical_out
	retw
