.text
.code16
.globl  lock_acquire
.globl  lock_release
.globl 	cond_wait
.globl 	cond_signal
.globl 	cond_broadcast


	.set	L_WAITING, 0
	.set	L_OWNER, 2

lock_acquire:				# 0x1390
	call	critical_in		# not change bp
	pushw	%bp
	movw	%sp, %bp
	pushw	4(%bp)
	call	l_acquire
	addw	$2, %sp
	popw	%bp
	call	critical_out
	retw

l_acquire:
	pushw	%bp
	movw	%sp, %bp
	movw	(curr_thrd), %ax	# ax: current thrd
	movw	4(%bp), %bx		# lock pointer
	movw	L_OWNER(%bx), %dx
	cmpw	$0, %dx
	je	l_hold
	cmpw	%ax, %dx
	je	l_got
	pushw	L_WAITING(%bx)
	pushw	%ax
	call	enQueue			# not change bp
	addw	$4, %sp
	call	sleep
	jmp	l_got
l_hold:					/* 0x13c8 */
	movw	%ax, L_OWNER(%bx)
l_got:
	popw	%bp
	retw	

lock_release:
	call	critical_in		# not change bp
	pushw	%bp
	movw	%sp, %bp
	pushw	4(%bp)
	call	l_release
	addw	$2, %sp
	popw	%bp
	call	critical_out
	retw

l_release:				/* 0x13e1 */
	pushw	%bp
	movw	%sp, %bp		
	movw	(curr_thrd), %ax	# ax: current thrd
	movw	4(%bp), %bx		# bx: lock pointer
	movw	L_OWNER(%bx), %dx
	cmpw	%ax, %dx
	jne	l_rel_done
	pushw	%bx			# save bx
	pushw	L_WAITING(%bx)
	call	deQueue			# not change bp
	addw	$2, %sp
	popw	%bx
	movw	%ax, L_OWNER(%bx)
	cmpw	$0, %ax
	je	l_rel_done
	pushw	%ax
	call	unblock
	addw	$2, %sp
l_rel_done:
	popw	%bp
	retw	
	

	.set	C_WAITING, 0
cond_wait:				# 0x11b1
	call	critical_in
	pushw	%bp
	movw	%sp, %bp
	pushw	6(%bp)
	call	l_release
	movw	4(%bp), %bx
	pushw	C_WAITING(%bx)
	pushw	(curr_thrd)
	call	enQueue
	addw	$4, %sp
	call	sleep
	call	l_acquire
	addw	$2, %sp
	popw	%bp
	call	critical_out
	retw

cond_signal:
	call	critical_in
	pushw	%bp
	movw	%sp, %bp
	movw	4(%bp), %bx
	pushw	C_WAITING(%bx)
	call	deQueue
	addw	$2, %sp
	cmpw	$0, %ax
	je	c_signal_done
	pushw	%ax
	call	unblock
	addw	$2, %sp
c_signal_done:
	popw	%bp
	call	critical_out
	retw

cond_broadcast:
	call	critical_in
	pushw	%bp
	movw	%sp, %bp
	movw	4(%bp), %bx
	pushw	C_WAITING(%bx)
	call	unblockQ
	addw	$2, %sp
	popw	%bp
	call	critical_out
	retw

