.data

lock_q:				# 0x273c
	.word 0			# head
	.word 0			# tail
lk:				# 0x2740
	.word lock_q
	.word 0


cond_q_get:				
	.word 0			# head
	.word 0			# tail
condVar_get:			# 0x2744
	.word cond_q_get

cond_q_put:				
	.word 0			# head
	.word 0			# tail
condVar_put:			
	.word cond_q_put

full:
	.word 0

	.set 	MB_SZ, 0x100

mbox:
	.fill	MB_SZ

rd_head:
	.word	0
wr_head:
	.word	0
mb_full:
	.word	0

.text
.code16
.globl mb_put_asyn
.globl mb_put_sync
.globl mb_get

mb_put_asyn:
        pushw   %bp
        movw    %sp, %bp
        pushw   $lk
        call    lock_acquire
        movw    (mb_full), %ax
        cmpw    $0, %ax
        jne      mb_put_asyn_done
        movw    (wr_head), %bx
        movw    4(%bp), %ax
        movw    %ax, mbox(%bx)
        incw    %bx
	incw	%bx
        movw    $MB_SZ, %ax
        notw    %ax
        andw    %ax, %bx
        movw    %bx, (wr_head)
        movw    (rd_head), %ax
        cmpw    %ax, %bx
        jne     mb_put_asyn_b
        movw    $1, (mb_full)
mb_put_asyn_b:
	pushw	$condVar_get
	call	cond_signal
	addw	$2, %sp
mb_put_asyn_done:
	call	lock_release
	addw	$2, %sp
	popw	%bp
	retw
	

mb_put_sync:
	pushw	%bp
	movw	%sp, %bp
	pushw	$lk
	call	lock_acquire
	addw	$2, %sp
mb_out_sync_loop:
	movw	(mb_full), %ax
	cmpw	$0, %ax
	je	mb_put_a
	pushw	$lk
	pushw	$condVar_put
	call	cond_wait
	addw	$4, %sp
	jmp	mb_out_sync_loop
mb_put_a:
	movw	(wr_head), %bx
	movw	4(%bp),	%ax
	movw	%ax, mbox(%bx)
	incw	%bx
	incw	%bx
	movw	$MB_SZ, %ax
	notw	%ax
	andw	%ax, %bx
	movw	%bx, (wr_head)
	movw	(rd_head), %ax
	cmpw	%ax, %bx
	jne	mb_put_b
	movw	$1, (mb_full)
mb_put_b:
	pushw	$condVar_get
	call	cond_signal
	addw	$2, %sp
	pushw	$lk
	call	lock_release
	addw	$2, %sp
	popw	%bp
	retw


mb_get:					/* 0x1511 */
        pushw   $lk
        call    lock_acquire
	addw	$2, %sp
mb_get_loop:
	movw	(wr_head), %ax
	movw	(rd_head), %bx
	cmpw	%ax, %bx
	jne	mb_get_a
        movw    (mb_full), %ax
        cmpw    $1, %ax
        je      mb_get_a
	# empty
	pushw	$lk
	pushw	$condVar_get
	call	cond_wait
	addw	$4, %sp
	jmp	mb_get_loop
mb_get_a:
	movw	$0, (mb_full)
	movw	(rd_head), %bx
	movw	mbox(%bx), %ax
	pushw	%ax
	incw	%bx
	incw	%bx
	movw	$MB_SZ, %ax
	notw	%ax
	andw	%ax, %bx
	movw	%bx, (rd_head)
        pushw   $condVar_put
        call    cond_signal
	addw	$2, %sp
	pushw	$lk
	call	lock_release
	addw	$2, %sp
	popw	%ax
	retw


